﻿using System;

﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using TelerikMvcMultiSelectText.Models;

namespace TelerikMvcMultiSelectText.Controllers
{
    public partial class GridController : Controller
    {
        public ActionResult EditTest()
        {
            OrderViewModel test = new OrderViewModel();
            test.OrderID = 1;
            return View(test);
        }

        [HttpPost]
        public ActionResult EditTest([DataSourceRequest]DataSourceRequest request, OrderViewModel data)
        {
            if (data != null && ModelState.IsValid)
            {
                // Update
                if (data.Team != null)
                {
                    int count = data.Team.Count;
                }

            }

            return View(data);
        }

        public ActionResult Orders_Read([DataSourceRequest]DataSourceRequest request)
        {
            List<OrderViewModel> result = Enumerable.Range(1, 10).Select(i => new OrderViewModel
            {
                OrderID = i,
                Freight = i * 10,
                ShipName = "ShipName " + i,
                ShipCity = "ShipCity " + i,
                Team = null
            }).ToList();

            OrderViewModel order = new OrderViewModel
            {
                OrderID = 15,
                Freight = 15 * 10,
                ShipName = "ShipName " + 15,
                ShipCity = "ShipCity " + 15,
                Team = new List<Person>()
            };

            Person p = new Person();
            p.Id = 1;
            p.LastName = "Person 1";
            p.FirstName = "FirstName 1";

            order.Team.Add(p);

            result.Add(order);

            return Json(result.ToDataSourceResult(request));
        }

        [HttpPost]
        public ActionResult Orders_Update([DataSourceRequest]DataSourceRequest request, OrderViewModel data)
        {
            if (data != null && ModelState.IsValid)
            {
                // Update
                //int count = data.Team.Count;
            }

            return Json(new[] { data }.ToDataSourceResult(request, ModelState));
        }

        public JsonResult TeamMemberRead()
        {
            List<Person> result = new List<Person>();
            Person p = new Person();
            p.Id = 1;
            p.LastName = "Person 1";
            p.FirstName = "FirstName 1";
            result.Add(p);
            Person p2 = new Person();
            p2.Id = 2;
            p2.LastName = "Person 2";
            p2.FirstName = "FirstName 2";
            result.Add(p2);
            Person p3 = new Person();
            p3.Id = 3;
            p3.LastName = "Person 3";
            p3.FirstName = "FirstName 3";
            result.Add(p3);
            return Json(result, JsonRequestBehavior.AllowGet);
        }

    }
}
